=== debian/changelog ===
ueberzugpp (2.8.6) unstable; urgency=medium

  * Initial release.

 -- JustKidding <jk@vin.ovh>  Wed, 31 May 2023 07:35:31 -0400
