=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
export DH_VERBOSE := 1
%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_WAYLAND=ON \
		-DFETCHCONTENT_FULLY_DISCONNECTED=ON
